diff -NurpP --minimal linux-2.4.24/kernel/fork.c linux-2.4.24-vs1.24/kernel/fork.c
--- linux-2.4.24/kernel/fork.c	Fri Nov 28 19:26:21 2003
+++ linux-2.4.24-vs1.24/kernel/fork.c	Sat Jan 17 05:27:22 2004
@@ -22,6 +22,7 @@
 #include <linux/namespace.h>
 #include <linux/personality.h>
 #include <linux/compiler.h>
+#include <linux/vcontext.h>
 
 #include <asm/pgtable.h>
 #include <asm/pgalloc.h>
@@ -659,9 +660,12 @@ int do_fork(unsigned long clone_flags, u
 	if (!p)
 		goto fork_out;
 
-	*p = *current;
-
 	retval = -EAGAIN;
+	*p = *current;
+	if (p->s_info && (p->s_info->flags & VX_INFO_NPROC)) {
+		if (atomic_read(&p->s_info->refcount) >= p->rlim[RLIMIT_NPROC].rlim_max)
+			goto bad_fork_free;
+	}
 	/*
 	 * Check if we are over our maximum process limit, but be sure to
 	 * exclude root. This is needed to make it possible for login and
@@ -671,6 +675,9 @@ int do_fork(unsigned long clone_flags, u
 	if (atomic_read(&p->user->processes) >= p->rlim[RLIMIT_NPROC].rlim_cur
 	              && !capable(CAP_SYS_ADMIN) && !capable(CAP_SYS_RESOURCE))
 		goto bad_fork_free;
+
+	vx_assign_info(p);
+	vx_assign_ip_info(p->ip_info);
 
 	atomic_inc(&p->user->__count);
 	atomic_inc(&p->user->processes);
diff -NurpP --minimal linux-2.4.24/kernel/printk.c linux-2.4.24-vs1.24/kernel/printk.c
--- linux-2.4.24/kernel/printk.c	Fri Nov 28 19:26:21 2003
+++ linux-2.4.24-vs1.24/kernel/printk.c	Sat Jan 17 05:27:22 2004
@@ -26,6 +26,7 @@
 #include <linux/module.h>
 #include <linux/interrupt.h>			/* For in_interrupt() */
 #include <linux/config.h>
+#include <linux/vcontext.h>
 
 #include <asm/uaccess.h>
 
@@ -175,6 +176,9 @@ int do_syslog(int type, char * buf, int 
 	int do_clear = 0;
 	char c;
 	int error = 0;
+
+	if (!capable(CAP_SYS_ADMIN) && !vx_check(0, VX_ADMIN))
+		return -EPERM;
 
 	switch (type) {
 	case 0:		/* Close log */
diff -NurpP --minimal linux-2.4.24/kernel/sched.c linux-2.4.24-vs1.24/kernel/sched.c
--- linux-2.4.24/kernel/sched.c	Fri Nov 28 19:26:21 2003
+++ linux-2.4.24-vs1.24/kernel/sched.c	Sat Jan 17 05:27:22 2004
@@ -29,6 +29,7 @@
 #include <linux/completion.h>
 #include <linux/prefetch.h>
 #include <linux/compiler.h>
+#include <linux/vcontext.h>
 
 #include <asm/uaccess.h>
 #include <asm/mmu_context.h>
@@ -165,7 +166,12 @@ static inline int goodness(struct task_s
 		 * Don't do any other calculations if the time slice is
 		 * over..
 		 */
-		weight = p->counter;
+		if (p->s_info && (p->s_info->flags & VX_INFO_SCHED)) {
+			weight = atomic_read(&p->s_info->ticks) /
+				atomic_read(&p->s_info->refcount);
+			weight = (weight+p->counter) >> 1;
+		} else
+			weight = p->counter;
 		if (!weight)
 			goto out;
 			
@@ -618,8 +624,19 @@ repeat_schedule:
 
 		spin_unlock_irq(&runqueue_lock);
 		read_lock(&tasklist_lock);
-		for_each_task(p)
+		/*
+			Reset the s_info->ticks to the sum off all
+			member processes p->counter
+		*/
+		for_each_task(p) {
+			if (p->s_info && (p->s_info->flags & VX_INFO_SCHED))
+				atomic_set(&p->s_info->ticks, 0);
+		}
+		for_each_task(p) {
 			p->counter = (p->counter >> 1) + NICE_TO_TICKS(p->nice);
+			if (p->s_info && (p->s_info->flags & VX_INFO_SCHED))
+				atomic_add(p->counter, &p->s_info->ticks);
+		}
 		read_unlock(&tasklist_lock);
 		spin_lock_irq(&runqueue_lock);
 		goto repeat_schedule;
diff -NurpP --minimal linux-2.4.24/kernel/signal.c linux-2.4.24-vs1.24/kernel/signal.c
--- linux-2.4.24/kernel/signal.c	Fri Jun 13 16:51:39 2003
+++ linux-2.4.24-vs1.24/kernel/signal.c	Sat Jan 17 05:27:22 2004
@@ -13,6 +13,7 @@
 #include <linux/smp_lock.h>
 #include <linux/init.h>
 #include <linux/sched.h>
+#include <linux/vswitch.h>
 
 #include <asm/uaccess.h>
 
@@ -621,7 +622,9 @@ kill_pg_info(int sig, struct siginfo *in
 		retval = -ESRCH;
 		read_lock(&tasklist_lock);
 		for_each_task(p) {
-			if (p->pgrp == pgrp && thread_group_leader(p)) {
+			if (p->pgrp == pgrp && thread_group_leader(p) &&
+				((long)info == 1 ||
+				vx_check(p->vx_id, VX_IDENT))) {
 				int err = send_sig_info(sig, info, p);
 				if (retval)
 					retval = err;
@@ -675,7 +678,20 @@ kill_proc_info(int sig, struct siginfo *
                        if (tg)
                                p = tg;
                 }
-		error = send_sig_info(sig, info, p);
+		switch ((unsigned long)info) {
+		case 0:
+			if (vx_check(p->vx_id, VX_IDENT))
+				error = send_sig_info(sig, info, p);
+			break;
+		case 1:
+			error = send_sig_info(sig, info, p);
+			break;
+		default:
+			if ((info->si_code == SI_KERNEL)
+				|| vx_check(p->vx_id, VX_IDENT))
+				error = send_sig_info(sig, info, p);
+			break;
+		}
 	}
 	read_unlock(&tasklist_lock);
 	return error;
@@ -699,7 +715,9 @@ static int kill_something_info(int sig, 
 
 		read_lock(&tasklist_lock);
 		for_each_task(p) {
-			if (p->pid > 1 && p != current && thread_group_leader(p)) {
+			if (p->pid > 1 && p != current &&
+				thread_group_leader(p) &&
+				vx_check(p->vx_id, VX_IDENT)) {
 				int err = send_sig_info(sig, info, p);
 				++count;
 				if (err != -EPERM)
diff -NurpP --minimal linux-2.4.24/kernel/sys.c linux-2.4.24-vs1.24/kernel/sys.c
--- linux-2.4.24/kernel/sys.c	Fri Nov 28 19:26:21 2003
+++ linux-2.4.24-vs1.24/kernel/sys.c	Sat Jan 17 05:27:23 2004
@@ -6,14 +6,17 @@
 
 #include <linux/module.h>
 #include <linux/mm.h>
+#include <linux/vmalloc.h>
 #include <linux/utsname.h>
 #include <linux/mman.h>
 #include <linux/smp_lock.h>
 #include <linux/notifier.h>
+#include <linux/kmod.h>
 #include <linux/reboot.h>
 #include <linux/prctl.h>
 #include <linux/init.h>
 #include <linux/highuid.h>
+#include <linux/vcontext.h>
 
 #include <asm/uaccess.h>
 #include <asm/io.h>
@@ -277,6 +280,67 @@ asmlinkage long sys_getpriority(int whic
 	return retval;
 }
 
+/*
+ *      vshelper path is set via /proc/sys
+ *      invoked by vserver sys_reboot(), with
+ *      the following arguments
+ *
+ *      argv [0] = vshelper_path;
+ *      argv [1] = context identifier
+ *      argv [2] = "restart", "halt", "poweroff", ...
+ *      argv [3] = additional argument (restart2)
+ *
+ *      envp [*] = type-specific parameters
+ */
+char vshelper_path[255] = "/sbin/vshelper";
+
+long vs_reboot(unsigned int cmd, void * arg)
+{
+	char id_buf[8], cmd_buf[32];
+	char uid_buf[32], pid_buf[32];
+        char buffer[256];
+
+	char *argv[] = {vshelper_path, id_buf, NULL, NULL, 0};
+	char *envp[] = {"HOME=/", "TERM=linux",
+			"PATH=/sbin:/usr/sbin:/bin:/usr/bin",
+			uid_buf, pid_buf, cmd_buf, 0};
+
+	snprintf(id_buf, sizeof(id_buf)-1, "%d", current->vx_id);
+
+	snprintf(cmd_buf, sizeof(cmd_buf)-1, "VS_CMD=%08x", cmd);
+	snprintf(uid_buf, sizeof(uid_buf)-1, "VS_UID=%d", current->uid);
+	snprintf(pid_buf, sizeof(pid_buf)-1, "VS_PID=%d", current->pid);
+
+        switch (cmd) {
+        case LINUX_REBOOT_CMD_RESTART:
+		argv[2] = "restart";
+		break;	
+
+	case LINUX_REBOOT_CMD_HALT:
+		argv[2] = "halt";
+		break;	
+
+	case LINUX_REBOOT_CMD_POWER_OFF:
+		argv[2] = "poweroff";
+		break;	
+
+	case LINUX_REBOOT_CMD_RESTART2:
+		if (strncpy_from_user(&buffer[0], (char *)arg, sizeof(buffer) - 1) < 0)
+			return -EFAULT;
+		argv[3] = buffer;
+	default:
+		argv[2] = "restart2";
+		break;	
+	}
+
+	if (call_usermodehelper(*argv, argv, envp)) {
+		printk( KERN_WARNING
+		    "vs_reboot(): failed to exec (%s %s %s %s)\n",
+		    vshelper_path, argv[1], argv[2], argv[3]);
+		return -EPERM;
+	}
+	return 0;
+}
 
 /*
  * Reboot system call: for obvious reasons only root may call it,
@@ -300,6 +364,9 @@ asmlinkage long sys_reboot(int magic1, i
 			magic2 != LINUX_REBOOT_MAGIC2B))
 		return -EINVAL;
 
+	if (!vx_check(0, VX_ADMIN | VX_WATCH))
+		return vs_reboot(cmd, arg);
+
 	lock_kernel();
 	switch (cmd) {
 	case LINUX_REBOOT_CMD_RESTART:
@@ -513,7 +580,7 @@ static int set_user(uid_t new_ruid, int 
 {
 	struct user_struct *new_user;
 
-	new_user = alloc_uid(new_ruid);
+	new_user = alloc_uid(current->vx_id, new_ruid);
 	if (!new_user)
 		return -EAGAIN;
 	switch_uid(new_user);
@@ -1025,9 +1092,18 @@ DECLARE_RWSEM(uts_sem);
 asmlinkage long sys_newuname(struct new_utsname * name)
 {
 	int errno = 0;
+	struct new_utsname tmp,*pttmp;
 
 	down_read(&uts_sem);
-	if (copy_to_user(name,&system_utsname,sizeof *name))
+	if (current->s_info) {
+		tmp = system_utsname;
+		strcpy (tmp.nodename,current->s_info->nodename);
+		strcpy (tmp.domainname,current->s_info->domainname);
+		pttmp = &tmp;
+	}
+	else
+		pttmp = &system_utsname;
+	if (copy_to_user(name,pttmp,sizeof *name))
 		errno = -EFAULT;
 	up_read(&uts_sem);
 	return errno;
@@ -1036,6 +1112,7 @@ asmlinkage long sys_newuname(struct new_
 asmlinkage long sys_sethostname(char *name, int len)
 {
 	int errno;
+	char *nodename;
 	char tmp[__NEW_UTS_LEN];
 
 	if (!capable(CAP_SYS_ADMIN))
@@ -1044,9 +1121,12 @@ asmlinkage long sys_sethostname(char *na
 		return -EINVAL;
 	down_write(&uts_sem);
 	errno = -EFAULT;
+	nodename = system_utsname.nodename;
+	if (current->s_info)
+		nodename = current->s_info->nodename;
 	if (!copy_from_user(tmp, name, len)) {
-		memcpy(system_utsname.nodename, tmp, len);
-		system_utsname.nodename[len] = 0;
+		memcpy(nodename, tmp, len);
+		nodename[len] = 0;
 		errno = 0;
 	}
 	up_write(&uts_sem);
@@ -1056,15 +1136,19 @@ asmlinkage long sys_sethostname(char *na
 asmlinkage long sys_gethostname(char *name, int len)
 {
 	int i, errno;
+	char *nodename;
 
 	if (len < 0)
 		return -EINVAL;
 	down_read(&uts_sem);
-	i = 1 + strlen(system_utsname.nodename);
+	nodename = system_utsname.nodename;
+	if (current->s_info)
+		nodename = current->s_info->nodename;
+	i = 1 + strlen(nodename);
 	if (i > len)
 		i = len;
 	errno = 0;
-	if (copy_to_user(name, system_utsname.nodename, i))
+	if (copy_to_user(name, nodename, i))
 		errno = -EFAULT;
 	up_read(&uts_sem);
 	return errno;
@@ -1077,6 +1161,7 @@ asmlinkage long sys_gethostname(char *na
 asmlinkage long sys_setdomainname(char *name, int len)
 {
 	int errno;
+	char *domainname;
 	char tmp[__NEW_UTS_LEN];
 
 	if (!capable(CAP_SYS_ADMIN))
@@ -1085,10 +1170,13 @@ asmlinkage long sys_setdomainname(char *
 		return -EINVAL;
 
 	down_write(&uts_sem);
+	domainname = system_utsname.domainname;
+	if (current->s_info)
+		domainname = current->s_info->domainname;
 	errno = -EFAULT;
 	if (!copy_from_user(tmp, name, len)) {
-		memcpy(system_utsname.domainname, tmp, len);
-		system_utsname.domainname[len] = 0;
+		memcpy(domainname, tmp, len);
+		domainname[len] = 0;
 		errno = 0;
 	}
 	up_write(&uts_sem);
diff -NurpP --minimal linux-2.4.24/kernel/sysctl.c linux-2.4.24-vs1.24/kernel/sysctl.c
--- linux-2.4.24/kernel/sysctl.c	Fri Nov 28 19:26:21 2003
+++ linux-2.4.24-vs1.24/kernel/sysctl.c	Sat Jan 17 05:27:23 2004
@@ -31,6 +31,7 @@
 #include <linux/sysrq.h>
 #include <linux/highuid.h>
 #include <linux/swap.h>
+#include <linux/vcontext.h>
 
 #include <asm/uaccess.h>
 
@@ -80,6 +81,7 @@ extern int sem_ctls[];
 #endif
 
 extern int exception_trace;
+extern char vshelper_path[];
 
 #ifdef __sparc__
 extern char reboot_command [];
@@ -275,6 +277,8 @@ static ctl_table kern_table[] = {
 	{KERN_EXCEPTION_TRACE,"exception-trace",
 	 &exception_trace,sizeof(int),0644,NULL,&proc_dointvec},
 #endif	
+	{KERN_VSHELPER,"vshelper",
+	 &vshelper_path,256,0644,NULL,&proc_dostring,&sysctl_string},
 	{0}
 };
 
@@ -414,6 +418,8 @@ extern asmlinkage long sys_sysctl(struct
 
 static int test_perm(int mode, int op)
 {
+	if (!capable(CAP_SYS_ADMIN))
+		mode &= ~(0222);
 	if (!current->euid)
 		mode >>= 6;
 	else if (in_egroup_p(0))
@@ -829,7 +835,18 @@ static int proc_doutsstring(ctl_table *t
 		  void *buffer, size_t *lenp)
 {
 	int r;
+	ctl_table tmp;
 
+	/* HACK for per context hostname and domainname */
+	if (current->s_info) {
+		tmp = *table;
+		table = &tmp;
+
+		if (table->data == (void*)&system_utsname.nodename)
+			tmp.data = &current->s_info->nodename;
+		else if (table->data == (void*)&system_utsname.domainname)
+			tmp.data = &current->s_info->domainname;
+	}
 	if (!write) {
 		down_read(&uts_sem);
 		r=proc_dostring(table,0,filp,buffer,lenp);
diff -NurpP --minimal linux-2.4.24/kernel/timer.c linux-2.4.24-vs1.24/kernel/timer.c
--- linux-2.4.24/kernel/timer.c	Fri Nov 29 00:53:15 2002
+++ linux-2.4.24-vs1.24/kernel/timer.c	Sat Jan 17 05:27:22 2004
@@ -22,6 +22,7 @@
 #include <linux/smp_lock.h>
 #include <linux/interrupt.h>
 #include <linux/kernel_stat.h>
+#include <linux/vcontext.h>
 
 #include <asm/uaccess.h>
 
@@ -599,6 +600,8 @@ void update_process_times(int user_tick)
 
 	update_one_process(p, user_tick, system, cpu);
 	if (p->pid) {
+		if (p->s_info && (p->s_info->flags & VX_INFO_SCHED))
+			atomic_dec (&p->s_info->ticks);
 		if (--p->counter <= 0) {
 			p->counter = 0;
 			/*
@@ -752,6 +755,10 @@ asmlinkage unsigned long sys_alarm(unsig
  */
 asmlinkage long sys_getpid(void)
 {
+	if (current->s_info &&
+		current->s_info->initpid == current->tgid)
+		/* We are faking process 1 for this security context */
+		return 1;
 	return current->tgid;
 }
 
@@ -798,6 +805,10 @@ asmlinkage long sys_getppid(void)
 #endif
 		break;
 	}
+	if (pid && current->s_info
+		&& current->s_info->initpid == pid)
+		/* We are faking process 1 for this security context */
+		pid = 1;
 	return pid;
 }
 
diff -NurpP --minimal linux-2.4.24/kernel/user.c linux-2.4.24-vs1.24/kernel/user.c
--- linux-2.4.24/kernel/user.c	Fri Nov 28 19:26:21 2003
+++ linux-2.4.24-vs1.24/kernel/user.c	Sat Jan 17 05:27:22 2004
@@ -6,6 +6,19 @@
  * We have a per-user structure to keep track of how many
  * processes, files etc the user has claimed, in order to be
  * able to have per-user limits for system resources. 
+ *
+ * For the vserver project, the key is extended from UID to (SC,UID),
+ * with SC being the security context ID. Thus, each security context
+ * has independant per-UID resource usage counters.
+ *
+ * As a consequence, even if two UIDs are the same, the 'struct user *'
+ * in their task_struct could be different. I don't think any code cares.
+ *
+ * (vserver modifications done Sun Jan 13 08:48:45 CET 2002 by bof@bof.de)
+ *
+ * NOTE: For now, the hash function is unmodified: the same uid in several
+ * security contexts, will always sit on the same hash chain. This could
+ * be changed easily.
  */
 
 #include <linux/init.h>
@@ -56,7 +69,7 @@ static inline void uid_hash_remove(struc
 	*pprev = next;
 }
 
-static inline struct user_struct *uid_hash_find(uid_t uid, struct user_struct **hashent)
+static inline struct user_struct *uid_hash_find(int vx_id, uid_t uid, struct user_struct **hashent)
 {
 	struct user_struct *next;
 
@@ -65,7 +78,7 @@ static inline struct user_struct *uid_ha
 		struct user_struct *up = next;
 		if (next) {
 			next = up->next;
-			if (up->uid != uid)
+			if (up->uid != uid || up->vx_id != vx_id)
 				continue;
 			atomic_inc(&up->__count);
 		}
@@ -82,13 +95,13 @@ void free_uid(struct user_struct *up)
 	}
 }
 
-struct user_struct * alloc_uid(uid_t uid)
+struct user_struct * alloc_uid(int vx_id, uid_t uid)
 {
 	struct user_struct **hashent = uidhashentry(uid);
 	struct user_struct *up;
 
 	spin_lock(&uidhash_lock);
-	up = uid_hash_find(uid, hashent);
+	up = uid_hash_find(vx_id, uid, hashent);
 	spin_unlock(&uidhash_lock);
 
 	if (!up) {
@@ -98,6 +111,7 @@ struct user_struct * alloc_uid(uid_t uid
 		if (!new)
 			return NULL;
 		new->uid = uid;
+		new->vx_id = vx_id;
 		atomic_set(&new->__count, 1);
 		atomic_set(&new->processes, 0);
 		atomic_set(&new->files, 0);
@@ -107,7 +121,7 @@ struct user_struct * alloc_uid(uid_t uid
 		 * on adding the same user already..
 		 */
 		spin_lock(&uidhash_lock);
-		up = uid_hash_find(uid, hashent);
+		up = uid_hash_find(vx_id, uid, hashent);
 		if (up) {
 			kmem_cache_free(uid_cachep, new);
 		} else {
diff -NurpP --minimal linux-2.4.24/kernel/vcontext.c linux-2.4.24-vs1.24/kernel/vcontext.c
--- linux-2.4.24/kernel/vcontext.c	Thu Jan  1 01:00:00 1970
+++ linux-2.4.24-vs1.24/kernel/vcontext.c	Sat Jan 17 05:27:22 2004
@@ -0,0 +1,477 @@
+/*
+ *  linux/kernel/vcontext.c
+ *
+ *  Virtual Context Support
+ *
+ *  Copyright (C) 2003  Herbert Pötzl
+ *
+ *  V0.01  context helper
+ *
+ */
+
+#include <linux/config.h>
+#include <linux/linkage.h>
+#include <linux/utsname.h>
+#include <linux/slab.h>
+#include <linux/vcontext.h>
+#include <linux/vswitch.h>
+#include <linux/sched.h>
+#include <linux/kernel_stat.h>
+
+#include <asm/errno.h>
+#include <asm/uaccess.h>
+
+
+int vc_ctx_kill(uint32_t id, void *data)
+{
+	int retval, count=0;
+	struct vcmd_ctx_kill_v0 vc_data;
+	struct siginfo info;
+	struct task_struct *p;
+	pid_t initpid = 0;
+
+	if (copy_from_user (&vc_data, data, sizeof(vc_data)))
+		return -EFAULT;
+	if (!vx_check(0, VX_ADMIN))
+		return -EPERM;
+	
+	info.si_signo = vc_data.sig;
+	info.si_errno = 0;
+	info.si_code = SI_USER;
+	info.si_pid = current->pid;
+	info.si_uid = current->uid;
+
+	retval = -ESRCH;
+	read_lock(&tasklist_lock);
+	switch (vc_data.pid) {
+	case -1:
+	case  0:
+		for_each_task(p) {
+			if (!initpid && p->vx_id == id && p->s_info)
+				initpid = p->s_info->initpid;
+			if (p->vx_id == id  && p->pid > 1
+				&& (!vc_data.pid || initpid != p->pid)
+				&& thread_group_leader(p)) {
+				int err = send_sig_info(vc_data.sig, &info, p);
+
+				++count;
+				if (err != -EPERM)
+					retval = err;
+			}
+		}
+		break;
+		
+	default:
+	p = find_task_by_pid(vc_data.pid);
+		if (p) {
+			if (!thread_group_leader(p)) {
+				struct task_struct *tg;
+			
+				tg = find_task_by_pid(p->tgid);
+				if (tg)
+					p = tg;
+			}
+			if ((id == -1) || (p->vx_id == id))
+				retval = send_sig_info(vc_data.sig, &info, p);
+		}
+		break;
+	}
+	read_unlock(&tasklist_lock);
+	return retval;
+}
+
+int vc_get_rlimit(uint32_t id, void *data)
+{
+	return -ENOSYS;
+}
+
+int vc_set_rlimit(uint32_t id, void *data)
+{
+	return -ENOSYS;
+}
+
+int vc_get_rlimit_mask(uint32_t id, void *data)
+{
+	return -ENOSYS;
+}
+
+
+
+/*  system functions */
+
+
+/*
+ *	Alloc a new s_info to the current process and release
+ *	the one currently owned by the current process.
+ */
+static void vx_alloc_info(void)
+{
+	struct context_info *s_info;
+
+	s_info = kmalloc(sizeof(struct context_info), GFP_KERNEL);
+	if (s_info) {
+		int i;
+		memset (s_info, 0, sizeof(*s_info));
+		s_info->vx_id[0] = current->vx_id;
+		atomic_set(&s_info->refcount, 1);
+		atomic_set(&s_info->ticks, current->counter);
+		s_info->flags = 0;
+		s_info->initpid = 0;
+		s_info->nr_threads = 1;
+		s_info->total_forks = 0;
+		s_info->bias_cswtch = kstat.context_swtch;
+		s_info->bias_jiffies = jiffies;
+		s_info->bias_idle = init_tasks[0]->times.tms_utime +
+			init_tasks[0]->times.tms_stime;
+		for (i=0; i<RLIM_NLIMITS; i++) {
+			s_info->rlim[i] = 0xffffffff;
+			atomic_set(&s_info->res[i], 0);
+		}
+		down_read(&uts_sem);
+		if (current->s_info) {
+			strcpy(s_info->nodename, current->s_info->nodename);
+			strcpy(s_info->domainname, current->s_info->domainname);
+		} else {
+			strcpy(s_info->nodename, system_utsname.nodename);
+			strcpy(s_info->domainname, system_utsname.domainname);
+		}
+		up_read(&uts_sem);
+		vx_release_info(current);	
+		current->s_info = s_info;
+		/*
+			The current process is switching to a new context
+			so we preset the open file counter with
+			the file currently open by that process.
+			Some of those files may have been opened by
+			a parent, so do not strictly belong to this
+			process, so we kind of over bill the current process
+			but it is minimal.
+		*/
+		atomic_set(&s_info->res[RLIMIT_NOFILE],
+			atomic_read(&current->files->count));
+	}
+}
+
+rwlock_t ctx_ref_lock = RW_LOCK_UNLOCKED;
+
+/*
+ *	Increase the reference count on the context_info member of a task
+ */
+void vx_assign_info (struct task_struct *p)
+{
+	read_lock(&ctx_ref_lock);
+	if (p->s_info)
+		atomic_inc(&p->s_info->refcount);
+	read_unlock(&ctx_ref_lock);
+}
+
+/*
+ *	Decrease the reference count on the context_info member of a task
+ *	Free the struct if the reference count reach 0.
+ */
+void vx_release_info (struct task_struct *p)
+{
+	write_lock(&ctx_ref_lock);
+	if (p->s_info) {
+		if (atomic_dec_and_test(&p->s_info->refcount)) {
+			struct context_info *s_info;
+
+			s_info = p->s_info;
+			p->s_info = NULL;
+			kfree(s_info);
+		}
+	}
+	write_unlock(&ctx_ref_lock);
+}
+
+/*
+ *	Alloc a new ip_info to the current process and release
+ *	the one currently owned by the current process.
+ */
+static void vx_alloc_ip_info(void)
+{
+	struct iproot_info *ip_info =
+		kmalloc(sizeof(struct iproot_info), GFP_KERNEL);
+
+	memset(ip_info, 0, sizeof(*ip_info));
+	ip_info->mark = 0xdeadbeef;
+	atomic_set(&ip_info->refcount, 1);
+	vx_release_ip_info(current->ip_info);	
+	current->ip_info = ip_info;
+}
+
+/*
+ *	Increase the reference count on the ip_info member of a task
+ */
+void vx_assign_ip_info (struct iproot_info *ip_info)
+{
+	if (ip_info) {
+		atomic_inc(&ip_info->refcount);
+		if (ip_info->mark != 0xdeadbeef)
+			printk("vx_assign_ip_info: broken signature %08lx\n", ip_info->mark);
+	}
+}
+
+/*
+ *	Decrease the reference count on the ip_info struct
+ *	Free the struct if the reference count reach 0.
+ */
+void vx_release_ip_info (struct iproot_info *ip_info)
+{
+	if (ip_info)
+		if (atomic_dec_and_test(&ip_info->refcount))
+			kfree(ip_info);
+}
+
+
+static int vx_switch_user_struct(int new_context)
+{
+	struct user_struct *new_user;
+
+	new_user = alloc_uid(new_context, current->uid);
+	if (!new_user)
+		return -ENOMEM;
+
+	if (new_user != current->user) {
+		struct user_struct *old_user = current->user;
+
+		atomic_inc(&new_user->processes);
+		atomic_dec(&old_user->processes);
+		current->user = new_user;
+		free_uid(old_user);
+	} else
+		free_uid(new_user);
+	return 0;
+}
+
+static int vx_set_initpid(int flags)
+{
+	int ret = 0;
+	if (flags & VX_INFO_INIT) {
+		if (current->s_info == NULL)
+			ret = -EINVAL;
+		else if (current->s_info->initpid != 0)
+			ret = -EPERM;
+		else
+			current->s_info->initpid = current->tgid;
+	}
+	return ret;
+}
+
+
+/*  new security context (syscall) */
+
+/*
+ *	Change to a new security context and reduce the capability
+ *	basic set of the current process
+ */
+int vc_new_s_context(uint32_t ctx, void *data)
+{
+	int ret = -EPERM;
+	struct vcmd_new_s_context_v1 vc_data;
+
+	if (copy_from_user(&vc_data, data, sizeof(vc_data)))
+		return -EFAULT;
+	if (ctx == -1) {
+		if (current->s_info == NULL
+			|| !(current->s_info->flags & VX_INFO_LOCK)) {
+			/* Ok we allocate a new context. For now, we just increase */
+			/* it. Wrap around possible, so we loop */
+			static int new_xid = MAX_S_CONTEXT;
+			static spinlock_t alloc_ctx_lock = SPIN_LOCK_UNLOCKED;
+			int old_xid = current->vx_id;
+			int barrier = new_xid;
+			int valid = 0;
+
+			spin_lock(&alloc_ctx_lock);
+			do {
+				struct task_struct *p;
+				
+				valid = 1;
+				if (++new_xid > MAX_S_CONTEXT)
+					new_xid = MIN_D_CONTEXT;
+
+				/* Check if in use */
+				read_lock(&tasklist_lock);
+				for_each_task(p) {
+					if (p->vx_id == new_xid) {
+						valid = 0;
+						break;
+					}
+				}
+				read_unlock(&tasklist_lock);
+				
+				if (valid) {
+					current->vx_id = new_xid;
+					break;
+				}
+			} while (barrier != new_xid);
+			spin_unlock(&alloc_ctx_lock);
+			
+			if (!valid)
+				return -EDEADLK;
+			
+			ret = vx_switch_user_struct(new_xid);
+			if (ret == 0) {
+				current->cap_bset &= (~vc_data.remove_cap);
+				ret = new_xid;
+				vx_alloc_info();
+				if (current->s_info) {
+					vx_set_initpid(vc_data.flags);
+					current->s_info->flags |= vc_data.flags;
+				}
+			} else
+				current->vx_id = old_xid;
+		}
+	} else if (ctx == -2) {
+		ret = vx_set_initpid(vc_data.flags);
+		if (ret == 0) {
+			/* We keep the same vx_id, but lower the capabilities */
+			current->cap_bset &= (~vc_data.remove_cap);
+			ret = current->vx_id;
+			if (current->s_info) {
+				if (vc_data.flags & VX_INFO_INIT)
+					current->s_info->initpid = current->tgid;
+				current->s_info->flags |= vc_data.flags;
+			}
+		}
+	} else if (ctx <= 0 || ctx > MAX_S_CONTEXT) {
+		ret = -EINVAL;
+	} else if (vx_check(0, VX_ADMIN)
+		&& capable(CAP_SYS_ADMIN)
+		&& (current->s_info == NULL
+			||(current->s_info->flags & VX_INFO_LOCK) == 0)) {
+		/* The root context can become any context it wants */
+		int found = 0;
+		struct task_struct *p;
+
+		/* Check if in use so we reuse the same context_info */
+		read_lock(&tasklist_lock);
+		ret = ctx;
+		for_each_task(p) {
+			if (p->vx_id == ctx) {
+				found = 1;
+				if (p->s_info == NULL
+					|| !(p->s_info->flags & VX_INFO_PRIVATE)) {
+					vx_release_info(current);
+					vx_assign_info(p);
+					current->s_info = p->s_info;
+				}
+				else
+					ret = -EPERM;
+				break;
+			}
+		}
+		read_unlock(&tasklist_lock);
+		if (ret == ctx) {
+			ret = vx_switch_user_struct(ctx);
+			if (ret == 0) {
+				current->vx_id = ctx;
+				current->cap_bset &= (~vc_data.remove_cap);
+				if (!found)
+					vx_alloc_info();
+				if (current->s_info)
+					current->s_info->flags |= vc_data.flags;
+			}
+		}
+	}
+	return ret;
+}
+
+
+/*  set ipv4 root (syscall) */
+
+int vc_set_ipv4root(uint32_t nbip, void *data)
+{
+	int ret = -EPERM;
+	struct vcmd_set_ipv4root_v3 vc_data;
+	struct iproot_info *ip_info = current->ip_info;
+
+	if (copy_from_user (&vc_data, data, sizeof(vc_data)))
+		return -EFAULT;
+
+	if (nbip < 0 || nbip > NB_IPV4ROOT)
+		ret = -EINVAL;
+	if (!ip_info || ip_info->ipv4[0] == 0 || capable(CAP_NET_ADMIN))
+		// We are allowed to change everything
+		ret = 0;
+	else if (current->ip_info) {
+		// We are allowed to select a subset of the currently
+		// installed IP numbers. No new one allowed
+		// We can't change the broadcast address though
+		int i;
+		int found = 0;
+		for (i=0; i<nbip; i++) {
+			int j;
+			__u32 ipi = vc_data.ip_mask_pair[i].ip;
+			for (j=0; j<ip_info->nbipv4; j++) {
+				if (ipi == ip_info->ipv4[j]) {
+					found++;
+					break;
+				}
+			}
+		}
+		if (found == nbip && vc_data.broadcast == ip_info->v4_bcast)
+			ret = 0;
+	}
+	if (ret == 0) {
+		int i;
+
+		vx_alloc_ip_info(); /* release existing? */
+		ip_info = current->ip_info;
+		ip_info->nbipv4 = nbip;
+		for (i=0; i<nbip; i++) {
+			ip_info->ipv4[i] = vc_data.ip_mask_pair[i].ip;
+			ip_info->mask[i] = vc_data.ip_mask_pair[i].mask;
+		}
+		ip_info->v4_bcast = vc_data.broadcast;
+	}
+	return ret;
+}
+
+
+#include <linux/proc_fs.h>
+
+int vx_proc_ioctl(struct inode * inode, struct file * filp,
+	unsigned int cmd, unsigned long arg)
+{
+	struct proc_dir_entry *entry;
+	int error = 0;
+	int flags;
+
+	if (inode->i_ino < PROC_DYNAMIC_FIRST ||
+		inode->i_ino >= PROC_DYNAMIC_FIRST+PROC_NDYNAMIC)
+		return -ENOTTY;
+
+	entry = (struct proc_dir_entry *) inode->u.generic_ip;
+
+	switch(cmd) {
+	case FIOC_GETXFLG: {
+		/* fixme: if stealth, return -ENOTTY */
+		error = -EPERM;
+		flags = entry->vx_flags;
+		if (capable(CAP_CONTEXT))
+			error = put_user(flags, (int *) arg);
+		break;
+	}
+	case FIOC_SETXFLG: {
+		/* fixme: if stealth, return -ENOTTY */
+		error = -EPERM;
+		if (!capable(CAP_CONTEXT))
+			break;
+		error = -EROFS;
+		if (IS_RDONLY(inode))
+			break;
+		error = -EFAULT;
+		if (get_user(flags, (int *) arg))
+			break;
+		error = 0;
+		entry->vx_flags = flags;
+		break;
+	}
+	default:
+		return -ENOTTY;
+	}
+	return error;
+}
+
diff -NurpP --minimal linux-2.4.24/kernel/vswitch.c linux-2.4.24-vs1.24/kernel/vswitch.c
--- linux-2.4.24/kernel/vswitch.c	Thu Jan  1 01:00:00 1970
+++ linux-2.4.24-vs1.24/kernel/vswitch.c	Sat Jan 17 05:27:22 2004
@@ -0,0 +1,71 @@
+/*
+ *  linux/kernel/vswitch.c
+ *
+ *  Virtual Context Support
+ *
+ *  Copyright (C) 2003  Herbert Pötzl
+ *
+ *  V0.01  syscall switch
+ *  V0.02  added signal to context
+ *
+ */
+
+#include <linux/config.h>
+#include <linux/linkage.h>
+#include <asm/errno.h>
+
+#include <linux/vswitch.h>
+
+
+static inline int
+vc_get_version(uint32_t id)
+{
+	return VCI_VERSION;
+}
+
+
+extern int vc_new_s_context(uint32_t, void *);
+extern int vc_set_ipv4root(uint32_t, void *);
+
+extern int vc_get_rlimit(uint32_t, void *);
+extern int vc_set_rlimit(uint32_t, void *);
+extern int vc_get_rlimit_mask(uint32_t, void *);
+
+extern int vc_ctx_kill(uint32_t, void *);
+
+
+asmlinkage int
+sys_vserver(uint32_t cmd, uint32_t id, void *data)
+{
+	int ret = -EINVAL;
+
+	switch (cmd) {
+	case VCMD_get_version:
+		ret = vc_get_version(id);
+		break;
+		
+	case VCMD_new_s_context:
+		ret = vc_new_s_context(id, data);
+		break;
+	case VCMD_set_ipv4root:
+		ret = vc_set_ipv4root(id, data);
+		break;
+
+	case VCMD_get_rlimit:
+		ret = vc_get_rlimit(id, data);
+		break;
+	case VCMD_set_rlimit:
+		ret = vc_set_rlimit(id, data);
+		break;
+	case VCMD_get_rlimit_mask:
+		ret = vc_get_rlimit_mask(id, data);
+		break;
+		
+	case VCMD_ctx_kill:
+		ret = vc_ctx_kill(id, data);
+		break;
+
+	}
+	return ret;
+}
+
diff -NurpP --minimal linux-2.4.24/net/ipv4/af_inet.c linux-2.4.24-vs1.24/net/ipv4/af_inet.c
--- linux-2.4.24/net/ipv4/af_inet.c	Fri Nov 28 19:26:21 2003
+++ linux-2.4.24-vs1.24/net/ipv4/af_inet.c	Sat Jan 17 05:27:23 2004
@@ -177,6 +177,8 @@ void inet_sock_destruct(struct sock *sk)
 
 	if (sk->protinfo.af_inet.opt)
 		kfree(sk->protinfo.af_inet.opt);
+	vx_release_ip_info(sk->ip_info);
+	sk->ip_info = NULL;
 	dst_release(sk->dst_cache);
 #ifdef INET_REFCNT_DEBUG
 	atomic_dec(&inet_sock_nr);
@@ -393,6 +395,9 @@ static int inet_create(struct socket *so
 	sk->protinfo.af_inet.mc_index	= 0;
 	sk->protinfo.af_inet.mc_list	= NULL;
 
+	sk->vx_id = current->vx_id;
+	sk->ip_info = NULL;
+
 #ifdef INET_REFCNT_DEBUG
 	atomic_inc(&inet_sock_nr);
 #endif
@@ -477,6 +482,11 @@ int inet_bind(struct socket *sock, struc
 	unsigned short snum;
 	int chk_addr_ret;
 	int err;
+	__u32 s_addr;	/* Address used for validation */
+	__u32 s_addr1;
+	__u32 s_addr2 = 0xffffffffl;	/* Optional address of the socket */
+					/* bcast in ipv4root world */
+	struct iproot_info *ip_info;
 
 	/* If the socket has its own bind function then use it. (RAW) */
 	if(sk->prot->bind)
@@ -485,7 +495,37 @@ int inet_bind(struct socket *sock, struc
 	if (addr_len < sizeof(struct sockaddr_in))
 		return -EINVAL;
 
-	chk_addr_ret = inet_addr_type(addr->sin_addr.s_addr);
+	s_addr = s_addr1 = addr->sin_addr.s_addr;
+	ip_info = current->ip_info;
+	if (ip_info) {
+		__u32 v4_bcast = ip_info->v4_bcast;
+		__u32 ipv4root = ip_info->ipv4[0];
+		int nbipv4 = ip_info->nbipv4;
+		if (s_addr == 0) {
+			s_addr = ipv4root;
+			if (nbipv4 > 1)
+				s_addr1 = 0;
+			else {
+				s_addr1 = ipv4root;
+				ip_info = NULL;
+			}
+			s_addr2 = v4_bcast;
+		} else if (s_addr == 0x0100007f) {
+			s_addr = s_addr1 = ipv4root;
+			ip_info = NULL;
+		} else if (s_addr != v4_bcast
+			&& s_addr != ipv4root) {
+			int i;
+			for (i=0; i<nbipv4; i++) {
+				if (s_addr == ip_info->ipv4[i])
+					break;
+			}
+			if (i == nbipv4)
+				return -EADDRNOTAVAIL;
+			ip_info = NULL;
+		}
+	}
+	chk_addr_ret = inet_addr_type(s_addr);
 
 	/* Not specified by any standard per-se, however it breaks too
 	 * many applications when removed.  It is unfortunate since
@@ -496,7 +536,7 @@ int inet_bind(struct socket *sock, struc
 	 */
 	if (sysctl_ip_nonlocal_bind == 0 && 
 	    sk->protinfo.af_inet.freebind == 0 &&
-	    addr->sin_addr.s_addr != INADDR_ANY &&
+	    s_addr != INADDR_ANY &&
 	    chk_addr_ret != RTN_LOCAL &&
 	    chk_addr_ret != RTN_MULTICAST &&
 	    chk_addr_ret != RTN_BROADCAST)
@@ -521,13 +561,19 @@ int inet_bind(struct socket *sock, struc
 	    (sk->num != 0))
 		goto out;
 
-	sk->rcv_saddr = sk->saddr = addr->sin_addr.s_addr;
+	sk->rcv_saddr = sk->saddr = s_addr1;
+	sk->rcv_saddr2 = s_addr2;
+	sk->ip_info = ip_info;
+	if (ip_info)
+		vx_assign_ip_info(ip_info);
 	if (chk_addr_ret == RTN_MULTICAST || chk_addr_ret == RTN_BROADCAST)
 		sk->saddr = 0;  /* Use device */
 
 	/* Make sure we are allowed to bind here. */
 	if (sk->prot->get_port(sk, snum) != 0) {
 		sk->saddr = sk->rcv_saddr = 0;
+		sk->ip_info = NULL;
+		vx_release_ip_info(ip_info);
 		err = -EADDRINUSE;
 		goto out;
 	}
